import type { SankeyEncodeChannels, WithDefaultEncode, PlotSankeyEncoderSpec, SemanticLabelOption, ChannelEncodeType, DataSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, TransformSpec, IElement } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
import type { ITextAttribute } from '@visactor/vrender-core';
export declare class SankeySemanticMark extends SemanticMark<PlotSankeyEncoderSpec, SankeyEncodeChannels> {
    static readonly type = PlotMakType.sankey;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    setDefaultDataTransform(): TransformSpec[];
    getDataIdOfLink(): string;
    setMultipleData(): DataSpec[];
    parseScaleByEncode(channel: SankeyEncodeChannels, option: ValueOf<WithDefaultEncode<PlotSankeyEncoderSpec, SankeyEncodeChannels>, SankeyEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotSankeyEncoderSpec, SankeyEncodeChannels>): GenerateBaseEncodeSpec<PlotSankeyEncoderSpec>;
    setMainMarkSpec(): {
        key: string;
    };
    protected setLabelTextGetter(channel: string, option: SemanticLabelOption | boolean): ChannelEncodeType<ITextAttribute['text']>;
    setMultiMarksSpec(): {
        id: string;
        type: string;
        glyphType: string;
        from: {
            data: string;
        };
        layout: {
            position: string;
            skipBeforeLayouted: boolean;
        };
        key: string;
        dependency: string[];
        animation: import("@visactor/vgrammar-core").MarkAnimationSpec;
        encode: Record<string, Partial<Partial<import("@visactor/vgrammar-core").LinkPathEncoderSpec>>> & {
            enter: any;
            update: (datum: any, el: IElement, params: any) => {
                direction: string;
                x0: any;
                x1: any;
                y0: any;
                y1: any;
                thickness: any;
                fill: any;
            };
        };
    }[];
}
